com.fasterxml.jackson.databind.util

## Class TokenBuffer.Parser

- java.lang.Object
- - com.fasterxml.jackson.core.JsonParser
  - - com.fasterxml.jackson.core.base.ParserMinimalBase
    - - com.fasterxml.jackson.databind.util.TokenBuffer.Parser

All Implemented Interfaces:
  com.fasterxml.jackson.core.Versioned, Closeable, AutoCloseable

Enclosing class:
  TokenBuffer

    protected static final class TokenBuffer.Parser
    extends com.fasterxml.jackson.core.base.ParserMinimalBase

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonParser

`com.fasterxml.jackson.core.JsonParser.Feature, com.fasterxml.jackson.core.JsonParser.NumberType`

### Field Summary

Fields
`protected com.fasterxml.jackson.core.util.ByteArrayBuilder` `_byteBuilder`
`protected boolean` `_closed`
`protected com.fasterxml.jackson.core.ObjectCodec` `_codec`
`protected boolean` `_hasNativeIds`
`protected boolean` `_hasNativeObjectIds`
`protected boolean` `_hasNativeTypeIds`
`protected com.fasterxml.jackson.core.JsonLocation` `_location`
`protected TokenBufferReadContext` `_parsingContext` Information about parser context, context in which the next token is to be parsed (root, array, object).
`protected TokenBuffer.Segment` `_segment` Currently active segment
`protected int` `_segmentPtr` Pointer to current token within current segment

### Fields inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

`_currToken, _lastClearedToken, BD_MAX_INT, BD_MAX_LONG, BD_MIN_INT, BD_MIN_LONG, BI_MAX_INT, BI_MAX_LONG, BI_MIN_INT, BI_MIN_LONG, CHAR_NULL, INT_0, INT_9, INT_APOS, INT_ASTERISK, INT_BACKSLASH, INT_COLON, INT_COMMA, INT_CR, INT_e, INT_E, INT_HASH, INT_LBRACKET, INT_LCURLY, INT_LF, INT_MINUS, INT_PERIOD, INT_PLUS, INT_QUOTE, INT_RBRACKET, INT_RCURLY, INT_SLASH, INT_SPACE, INT_TAB, MAX_ERROR_TOKEN_LENGTH, MAX_INT_D, MAX_INT_L, MAX_LONG_D, MIN_INT_D, MIN_INT_L, MIN_LONG_D, NO_BYTES, NO_INTS, NR_BIGDECIMAL, NR_BIGINT, NR_DOUBLE, NR_FLOAT, NR_INT, NR_LONG, NR_UNKNOWN`

### Fields inherited from class com.fasterxml.jackson.core.JsonParser

`_features, _requestPayload`

### Constructor Summary

Constructors
Constructor and Description
`Parser(TokenBuffer.Segment firstSeg, com.fasterxml.jackson.core.ObjectCodec codec, boolean hasNativeTypeIds, boolean hasNativeObjectIds)` Deprecated.
`Parser(TokenBuffer.Segment firstSeg, com.fasterxml.jackson.core.ObjectCodec codec, boolean hasNativeTypeIds, boolean hasNativeObjectIds, com.fasterxml.jackson.core.JsonStreamContext parentContext)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `_checkIsNumber()`
`protected int` `_convertNumberToInt(Number n)`
`protected long` `_convertNumberToLong(Number n)`
`protected Object` `_currentObject()`
`protected void` `_handleEOF()`
`boolean` `canReadObjectId()`
`boolean` `canReadTypeId()`
`void` `close()`
`BigInteger` `getBigIntegerValue()`
`byte[]` `getBinaryValue(com.fasterxml.jackson.core.Base64Variant b64variant)`
`com.fasterxml.jackson.core.ObjectCodec` `getCodec()`
`com.fasterxml.jackson.core.JsonLocation` `getCurrentLocation()`
`String` `getCurrentName()`
`BigDecimal` `getDecimalValue()`
`double` `getDoubleValue()`
`Object` `getEmbeddedObject()`
`float` `getFloatValue()`
`int` `getIntValue()`
`long` `getLongValue()`
`com.fasterxml.jackson.core.JsonParser.NumberType` `getNumberType()`
`Number` `getNumberValue()`
`Object` `getObjectId()`
`com.fasterxml.jackson.core.JsonStreamContext` `getParsingContext()`
`String` `getText()`
`char[]` `getTextCharacters()`
`int` `getTextLength()`
`int` `getTextOffset()`
`com.fasterxml.jackson.core.JsonLocation` `getTokenLocation()`
`Object` `getTypeId()`
`boolean` `hasTextCharacters()`
`boolean` `isClosed()`
`boolean` `isNaN()`
`String` `nextFieldName()`
`com.fasterxml.jackson.core.JsonToken` `nextToken()`
`void` `overrideCurrentName(String name)`
`com.fasterxml.jackson.core.JsonToken` `peekNextToken()`
`int` `readBinaryValue(com.fasterxml.jackson.core.Base64Variant b64variant, OutputStream out)`
`void` `setCodec(com.fasterxml.jackson.core.ObjectCodec c)`
`void` `setLocation(com.fasterxml.jackson.core.JsonLocation l)`
`com.fasterxml.jackson.core.Version` `version()`

### Methods inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

`_ascii, _asciiBytes, _constructError, _decodeBase64, _getCharDesc, _hasTextualNull, _longIntegerDesc, _longNumberDesc, _reportError, _reportError, _reportError, _reportInputCoercion, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOFInValue, _reportInvalidEOFInValue, _reportMissingRootWS, _reportUnexpectedChar, _throwInternal, _throwInvalidSpace, _wrapError, clearCurrentToken, currentToken, currentTokenId, getCurrentToken, getCurrentTokenId, getLastClearedToken, getValueAsBoolean, getValueAsDouble, getValueAsInt, getValueAsInt, getValueAsLong, getValueAsLong, getValueAsString, getValueAsString, hasCurrentToken, hasToken, hasTokenId, isExpectedStartArrayToken, isExpectedStartObjectToken, nextValue, reportInvalidNumber, reportOverflowInt, reportOverflowInt, reportOverflowInt, reportOverflowLong, reportOverflowLong, reportOverflowLong, reportUnexpectedNumberChar, skipChildren`

### Methods inherited from class com.fasterxml.jackson.core.JsonParser

`_codec, _constructError, _reportUnsupportedOperation, canParseAsync, canUseSchema, configure, currentName, disable, enable, finishToken, getBinaryValue, getBooleanValue, getByteValue, getCurrentValue, getFeatureMask, getFormatFeatures, getInputSource, getNonBlockingInputFeeder, getSchema, getShortValue, getText, getValueAsBoolean, getValueAsDouble, isEnabled, nextBooleanValue, nextFieldName, nextIntValue, nextLongValue, nextTextValue, overrideFormatFeatures, overrideStdFeatures, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, releaseBuffered, requiresCustomCodec, setCurrentValue, setFeatureMask, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError, setSchema`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _codec

    protected com.fasterxml.jackson.core.ObjectCodec _codec

#### _hasNativeTypeIds

    protected final boolean _hasNativeTypeIds

Since:
  2.3

#### _hasNativeObjectIds

    protected final boolean _hasNativeObjectIds

Since:
  2.3

#### _hasNativeIds

    protected final boolean _hasNativeIds

#### _segment

    protected TokenBuffer.Segment _segment

Currently active segment

#### _segmentPtr

    protected int _segmentPtr

Pointer to current token within current segment

#### _parsingContext

    protected TokenBufferReadContext _parsingContext

Information about parser context, context in which the next token is to be parsed (root, array, object).

#### _closed

    protected boolean _closed

#### _byteBuilder

    protected transient com.fasterxml.jackson.core.util.ByteArrayBuilder _byteBuilder

#### _location

    protected com.fasterxml.jackson.core.JsonLocation _location

### Constructor Detail

#### Parser

    @Deprecated
    public Parser(TokenBuffer.Segment firstSeg,
                              com.fasterxml.jackson.core.ObjectCodec codec,
                              boolean hasNativeTypeIds,
                              boolean hasNativeObjectIds)

Deprecated.

#### Parser

    public Parser(TokenBuffer.Segment firstSeg,
                  com.fasterxml.jackson.core.ObjectCodec codec,
                  boolean hasNativeTypeIds,
                  boolean hasNativeObjectIds,
                  com.fasterxml.jackson.core.JsonStreamContext parentContext)

### Method Detail

#### setLocation

    public void setLocation(com.fasterxml.jackson.core.JsonLocation l)

#### getCodec

    public com.fasterxml.jackson.core.ObjectCodec getCodec()

Specified by:
  `getCodec` in class `com.fasterxml.jackson.core.JsonParser`

#### setCodec

    public void setCodec(com.fasterxml.jackson.core.ObjectCodec c)

Specified by:
  `setCodec` in class `com.fasterxml.jackson.core.JsonParser`

#### version

    public com.fasterxml.jackson.core.Version version()

Specified by:
  `version` in interface `com.fasterxml.jackson.core.Versioned`
Specified by:
  `version` in class `com.fasterxml.jackson.core.JsonParser`

#### peekNextToken

    public com.fasterxml.jackson.core.JsonToken peekNextToken()
                                                       throws IOException

Throws:
  `IOException`

#### close

    public void close()
               throws IOException

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
Throws:
  `IOException`

#### nextToken

    public com.fasterxml.jackson.core.JsonToken nextToken()
                                                   throws IOException

Specified by:
  `nextToken` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
Throws:
  `IOException`

#### nextFieldName

    public String nextFieldName()
                         throws IOException

Overrides:
  `nextFieldName` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### isClosed

    public boolean isClosed()

Specified by:
  `isClosed` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### getParsingContext

    public com.fasterxml.jackson.core.JsonStreamContext getParsingContext()

Specified by:
  `getParsingContext` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### getTokenLocation

    public com.fasterxml.jackson.core.JsonLocation getTokenLocation()

Specified by:
  `getTokenLocation` in class `com.fasterxml.jackson.core.JsonParser`

#### getCurrentLocation

    public com.fasterxml.jackson.core.JsonLocation getCurrentLocation()

Specified by:
  `getCurrentLocation` in class `com.fasterxml.jackson.core.JsonParser`

#### getCurrentName

    public String getCurrentName()

Specified by:
  `getCurrentName` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### overrideCurrentName

    public void overrideCurrentName(String name)

Specified by:
  `overrideCurrentName` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### getText

    public String getText()

Specified by:
  `getText` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### getTextCharacters

    public char[] getTextCharacters()

Specified by:
  `getTextCharacters` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### getTextLength

    public int getTextLength()

Specified by:
  `getTextLength` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### getTextOffset

    public int getTextOffset()

Specified by:
  `getTextOffset` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### hasTextCharacters

    public boolean hasTextCharacters()

Specified by:
  `hasTextCharacters` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

#### isNaN

    public boolean isNaN()

Overrides:
  `isNaN` in class `com.fasterxml.jackson.core.JsonParser`

#### getBigIntegerValue

    public BigInteger getBigIntegerValue()
                                  throws IOException

Specified by:
  `getBigIntegerValue` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### getDecimalValue

    public BigDecimal getDecimalValue()
                               throws IOException

Specified by:
  `getDecimalValue` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### getDoubleValue

    public double getDoubleValue()
                          throws IOException

Specified by:
  `getDoubleValue` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### getFloatValue

    public float getFloatValue()
                        throws IOException

Specified by:
  `getFloatValue` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### getIntValue

    public int getIntValue()
                    throws IOException

Specified by:
  `getIntValue` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### getLongValue

    public long getLongValue()
                      throws IOException

Specified by:
  `getLongValue` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### getNumberType

    public com.fasterxml.jackson.core.JsonParser.NumberType getNumberType()
                                                                   throws IOException

Specified by:
  `getNumberType` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### getNumberValue

    public final Number getNumberValue()
                                throws IOException

Specified by:
  `getNumberValue` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### _convertNumberToInt

    protected int _convertNumberToInt(Number n)
                               throws IOException

Throws:
  `IOException`

#### _convertNumberToLong

    protected long _convertNumberToLong(Number n)
                                 throws IOException

Throws:
  `IOException`

#### getEmbeddedObject

    public Object getEmbeddedObject()

Overrides:
  `getEmbeddedObject` in class `com.fasterxml.jackson.core.JsonParser`

#### getBinaryValue

    public byte[] getBinaryValue(com.fasterxml.jackson.core.Base64Variant b64variant)
                          throws IOException,
                                 com.fasterxml.jackson.core.JsonParseException

Specified by:
  `getBinaryValue` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonParseException`

#### readBinaryValue

    public int readBinaryValue(com.fasterxml.jackson.core.Base64Variant b64variant,
                               OutputStream out)
                        throws IOException

Overrides:
  `readBinaryValue` in class `com.fasterxml.jackson.core.JsonParser`
Throws:
  `IOException`

#### canReadObjectId

    public boolean canReadObjectId()

Overrides:
  `canReadObjectId` in class `com.fasterxml.jackson.core.JsonParser`

#### canReadTypeId

    public boolean canReadTypeId()

Overrides:
  `canReadTypeId` in class `com.fasterxml.jackson.core.JsonParser`

#### getTypeId

    public Object getTypeId()

Overrides:
  `getTypeId` in class `com.fasterxml.jackson.core.JsonParser`

#### getObjectId

    public Object getObjectId()

Overrides:
  `getObjectId` in class `com.fasterxml.jackson.core.JsonParser`

#### _currentObject

    protected final Object _currentObject()

#### _checkIsNumber

    protected final void _checkIsNumber()
                                 throws com.fasterxml.jackson.core.JsonParseException

Throws:
  `com.fasterxml.jackson.core.JsonParseException`

#### _handleEOF

    protected void _handleEOF()
                       throws com.fasterxml.jackson.core.JsonParseException

Specified by:
  `_handleEOF` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
Throws:
  `com.fasterxml.jackson.core.JsonParseException`